## ros-rolling-robot-localization 3.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(robot_localization)

if(NOT WIN32)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  message(STATUS "${PROJECT_NAME}: You did not request a specific build type: selecting 'RelWithDebInfo'.")
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(diagnostic_msgs REQUIRED)
find_package(diagnostic_updater REQUIRED)
find_package(geographic_msgs REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(message_filters REQUIRED)
find_package(nav_msgs REQUIRED)
find_package(rosidl_default_generators REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(std_srvs REQUIRED)
find_package(tf2 REQUIRED)
find_package(tf2_eigen REQUIRED)
find_package(tf2_geometry_msgs REQUIRED)
find_package(tf2_ros REQUIRED)
find_package(Eigen3 REQUIRED)
find_package(Boost REQUIRED)
find_package(yaml_cpp_vendor REQUIRED)

# Geographiclib installs FindGeographicLib.cmake to this non-standard location
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "/usr/share/cmake/geographiclib/")
find_package(GeographicLib REQUIRED COMPONENTS STATIC)

set(library_name rl_lib)

rosidl_generate_interfaces(${PROJECT_NAME}
  "srv/FromLL.srv"
  "srv/GetState.srv"
  "srv/SetDatum.srv"
  "srv/SetPose.srv"
  "srv/ToggleFilterProcessing.srv"
  "srv/ToLL.srv"
  DEPENDENCIES
    builtin_interfaces
    geometry_msgs
    geographic_msgs
    diagnostic_msgs
  ADD_LINTER_TESTS
)

include_directories(SYSTEM ${Eigen_INCLUDE_DIRS})
include_directories(
  include
  ${EIGEN3_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
)

add_library(
  ${library_name}
  src/ekf.cpp
  src/ukf.cpp
  src/filter_base.cpp
  src/filter_utilities.cpp
  src/navsat_transform.cpp
  src/robot_localization_estimator.cpp
  src/ros_filter.cpp
  src/ros_filter_utilities.cpp
  src/ros_robot_localization_listener.cpp)

rosidl_get_typesupport_target(cpp_typesupport_target "${PROJECT_NAME}" "rosidl_typesupport_cpp")
target_link_libraries(${library_name} "${cpp_typesupport_target}")

add_executable(
  ekf_node
  src/ekf_node.cpp
)

add_executable(
  ukf_node
  src/ukf_node.cpp
)

add_executable(
  navsat_transform_node
  src/navsat_transform_node.cpp
)

add_executable(
  robot_localization_listener_node
  src/robot_localization_listener_node.cpp
)

target_link_libraries(
  ${library_name}
  ${GeographicLib_LIBRARIES}
  ${EIGEN3_LIBRARIES}
)

ament_target_dependencies(
  ${library_name}
  diagnostic_msgs
  diagnostic_updater
  geographic_msgs
  geometry_msgs
  message_filters
  nav_msgs
  rclcpp
  sensor_msgs
  std_msgs
  std_srvs
  tf2
  tf2_eigen
  tf2_geometry_msgs
  tf2_ros
  yaml_cpp_vendor
)

target_link_libraries(
  ekf_node
  ${library_name}
)

ament_target_dependencies(
  ekf_node
  rclcpp
)

target_link_libraries(
  ukf_node
  ${library_name}
)

ament_target_dependencies(
  ukf_node
  rclcpp
)

target_link_libraries(
  navsat_transform_node
  ${library_name}
)

ament_target_dependencies(
  navsat_transform_node
  rclcpp
)

target_link_libraries(
  robot_localization_listener_node
  ${library_name}
)

ament_target_dependencies(
  robot_localization_listener_node
  rclcpp
)

if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_cmake_cppcheck REQUIRED)
  find_package(ament_cmake_cpplint REQUIRED)
  find_package(ament_cmake_lint_cmake REQUIRED)
  find_package(ament_cmake_uncrustify REQUIRED)
  find_package(launch_testing_ament_cmake REQUIRED)

  #### FILTER BASE TESTS ####
  ament_add_gtest(filter_base-test test/test_filter_base.cpp)
  target_link_libraries(filter_base-test ${library_name})

  #### DIAGNOSTICS TESTS ####
  ament_add_gtest_executable(test_filter_base_diagnostics_timestamps
                    test/test_filter_base_diagnostics_timestamps.cpp)
  target_link_libraries(test_filter_base_diagnostics_timestamps ${library_name})

  rosidl_get_typesupport_target(cpp_typesupport_target "${PROJECT_NAME}" "rosidl_typesupport_cpp")
  target_link_libraries(test_filter_base_diagnostics_timestamps "${cpp_typesupport_target}")

  add_dependencies(test_filter_base_diagnostics_timestamps ekf_node)
  ament_add_test(test_filter_base_diagnostics_timestamps
    GENERATE_RESULT_FOR_RETURN_CODE_ZERO
    TIMEOUT 300
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/test/test_filter_base_diagnostics_timestamps.launch.py"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  )

  #### EKF TESTS ######
  ament_add_gtest(test_ekf test/test_ekf.cpp)
  target_link_libraries(test_ekf ${library_name})

  rosidl_get_typesupport_target(cpp_typesupport_target "${PROJECT_NAME}" "rosidl_typesupport_cpp")
  target_link_libraries(test_ekf "${cpp_typesupport_target}")

  ament_add_gtest_executable(test_ekf_localization_node_interfaces
                    test/test_ekf_localization_node_interfaces.cpp)
  target_link_libraries(test_ekf_localization_node_interfaces ${library_name})

  rosidl_get_typesupport_target(cpp_typesupport_target "${PROJECT_NAME}" "rosidl_typesupport_cpp")
  target_link_libraries(test_ekf_localization_node_interfaces "${cpp_typesupport_target}")

  add_dependencies(test_ekf_localization_node_interfaces ekf_node)
  ament_add_test(test_ekf_localization_node_interfaces
    GENERATE_RESULT_FOR_RETURN_CODE_ZERO
    TIMEOUT 300
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/test/test_ekf_localization_node_interfaces.launch.py"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  )

  #### UKF TESTS #####
  ament_add_gtest(test_ukf test/test_ukf.cpp)
  target_link_libraries(test_ukf ${library_name})

  rosidl_get_typesupport_target(cpp_typesupport_target "${PROJECT_NAME}" "rosidl_typesupport_cpp")
  target_link_libraries(test_ukf "${cpp_typesupport_target}")

  ament_add_gtest_executable(test_ukf_localization_node_interfaces
                    test/test_ukf_localization_node_interfaces.cpp)
  target_link_libraries(test_ukf_localization_node_interfaces ${library_name})

  rosidl_get_typesupport_target(cpp_typesupport_target "${PROJECT_NAME}" "rosidl_typesupport_cpp")
  target_link_libraries(test_ukf_localization_node_interfaces "${cpp_typesupport_target}")

  add_dependencies(test_ukf_localization_node_interfaces ukf_node)
  ament_add_test(test_ukf_localization_node_interfaces
    GENERATE_RESULT_FOR_RETURN_CODE_ZERO
    TIMEOUT 300
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/test/test_ukf_localization_node_interfaces.launch.py"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  )

  #### DATA TESTS #####
#  ament_add_gtest(test_ekf_localization_node_bag1 test/test_localization_node_bag_pose_tester.cpp)
#  target_link_libraries(test_ekf_localization_node_bag1 ${library_name})

#  ament_add_gtest(test_ekf_localization_node_bag2 test/test_localization_node_bag_pose_tester.cpp)
#  target_link_libraries(test_ekf_localization_node_bag2 ${library_name})

#  ament_add_gtest(test_ekf_localization_node_bag3 test/test_localization_node_bag_pose_tester.cpp)
#  target_link_libraries(test_ekf_localization_node_bag3 ${library_name})

#  ament_add_gtest(test_ukf_localization_node_bag1 test/test_localization_node_bag_pose_tester.cpp)
#  target_link_libraries(test_ukf_localization_node_bag1 ${library_name})

#  ament_add_gtest(test_ukf_localization_node_bag2 test/test_localization_node_bag_pose_tester.cpp)
#  target_link_libraries(test_ukf_localization_node_bag2 ${library_name})

#  ament_add_gtest(test_ukf_localization_node_bag3 test/test_localization_node_bag_pose_tester.cpp)
#  target_link_libraries(test_ukf_localization_node_bag3 ${library_name})

  #### RLE/RLL TESTS #####
  ament_add_gtest_executable(test_robot_localization_estimator
                  test/test_robot_localization_estimator.cpp)
  target_link_libraries(test_robot_localization_estimator ${library_name})
  rosidl_get_typesupport_target(cpp_typesupport_target "${PROJECT_NAME}" "rosidl_typesupport_cpp")
  target_link_libraries(test_robot_localization_estimator "${cpp_typesupport_target}")
  ament_add_test(test_robot_localization_estimator
    GENERATE_RESULT_FOR_RETURN_CODE_ZERO
    TIMEOUT 100
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/test/test_robot_localization_estimator.launch.py"
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  )

  ament_add_gtest_executable(test_ros_robot_localization_listener
                  test/test_ros_robot_localization_listener.cpp)
  target_link_libraries(test_ros_robot_localization_listener ${library_name})
  rosidl_get_typesupport_target(cpp_typesupport_target "${PROJECT_NAME}" "rosidl_typesupport_cpp")
  target_link_libraries(test_ros_robot_localization_listener "${cpp_typesupport_target}")
  ament_add_gtest_executable(test_ros_robot_localization_listener_publisher
                  test/test_ros_robot_localization_listener_publisher.cpp)
  target_link_libraries(test_ros_robot_localization_listener_publisher ${library_name})
  rosidl_get_typesupport_target(cpp_typesupport_target "${PROJECT_NAME}" "rosidl_typesupport_cpp")
  target_link_libraries(test_ros_robot_localization_listener_publisher "${cpp_typesupport_target}")
  ament_add_test(test_ros_robot_localization_listener
    GENERATE_RESULT_FOR_RETURN_CODE_ZERO
    TIMEOUT 100
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/test/test_ros_robot_localization_listener.launch.py"
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  )

  ament_cppcheck(LANGUAGE "c++")
  ament_cpplint()
  ament_lint_cmake()
  ament_uncrustify()

  install(
    TARGETS
    filter_base-test
    test_filter_base_diagnostics_timestamps
    test_ekf
    test_ekf_localization_node_interfaces
    test_ukf
    test_ukf_localization_node_interfaces
    #test_ekf_localization_node_bag1
    #test_ekf_localization_node_bag2
    #test_ekf_localization_node_bag3
    test_robot_localization_estimator
    test_ros_robot_localization_listener
    test_ros_robot_localization_listener_publisher
    #test_ukf_localization_node_bag1
    #test_ukf_localization_node_bag2
    #test_ukf_localization_node_bag3
    DESTINATION lib/${PROJECT_NAME}
  )

  # Install test launch config files.
  install(DIRECTORY
    test
    DESTINATION share/${PROJECT_NAME}
    USE_SOURCE_PERMISSIONS
  )
endif()

install(
  TARGETS
  navsat_transform_node
  ekf_node
  ukf_node
  robot_localization_listener_node
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

install(TARGETS ${library_name}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

# Install params config files.
install(DIRECTORY
  params
  launch
  DESTINATION share/${PROJECT_NAME}
  USE_SOURCE_PERMISSIONS
)

ament_export_include_directories(include)
ament_export_libraries(${library_name})
ament_export_dependencies(rosidl_default_runtime)
ament_package()

=== debian/changelog ===
ros-rolling-robot-localization (3.3.0-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Tom Moore <ayrton04@gmail.com>  Wed, 15 Sep 2021 18:53:24 -0000

ros-rolling-robot-localization (2.4.0-1focal) focal; urgency=high

  * Updated documentation
  * Added reset_on_time_jump option
  * Added feature to optionally publish utm frame as parent in navsat_transform_node
  * Moved global callback queue reset
  * Added initial_state parameter and documentation
  * Fixed ac/deceleration gains default logic
  * Added gravity parameter
  * Added delay and throttle if tf lookup fails
  * Fixed UKF IMUTwistBasicIO test
  * Added transform_timeout parameter
  * Set gps_odom timestamp before tf2 lookuptransform
  * Removed non-portable sincos calls
  * Simplified logic to account for correlated error
  * Added dynamic process noise covariance calculation
  * Fixed catkin_package Eigen warning
  * Added optional publication of acceleration state
  * Contributors: Brian Gerkey, Enrique Fernandez, Jochen Sprickerhof, Rein Appeldoorn, Simon Gene Gottlieb, Tom Moore

 -- Tom Moore <ayrton04@gmail.com>  Mon, 12 Jun 2017 07:00:00 -0000

ros-rolling-robot-localization (2.3.1-1focal) focal; urgency=high

  * Adding gitignore
  * Adding remaining wiki pages
  * Adding config and prep pages
  * Adding navsat_transform_node documentation
  * use_odometry_yaw fix for n_t_n
  * Fixing issue with manual pose reset when history is not empty
  * Getting inverse transform when looking up robot's pose.
  * Sphinx documentation
  * Removing forward slashes from navsat_transform input topics for template launch file
  * Adding example launch and parameter files for a two-level EKF setup with navsat_transform_node
  * Adding yaml file for navsat_transform_node, and moving parameter documentation to it.
  * Updating EKF and UKF parameter templates with usage comments
  * Contributors: Tom Moore, asimay

 -- Tom Moore <ayrton04@gmail.com>  Thu, 27 Oct 2016 07:00:00 -0000

ros-rolling-robot-localization (2.3.0-1focal) focal; urgency=high

  * Fixed issues with datum usage and frame_ids
  * Fixed comment for wait_for_datum
  * Fixing issue with non-zero navsat sensor orientation offsets
  * Fixing issue with base_link->gps transform wrecking the 'true' UTM position computation
  * Using correct covariance for filtered GPS
  * Fixed unitialized odometry covariance bug
  * Added filter history and measurement queue behavior
  * Changing output timestamp to more accurately use the time stamp of the most recently-processed measurement
  * Added TcpNoDelay()
  * Added parameter to make transform publishing optional
  * Fixed differential handling for pose data so that it doesn't care about the message's frame_id
  * Updated UKF config and launch
  * Added a test case for the timestamp diagnostics
  * Added reporting of bad timestamps via diagnostics
  * Updated tests to match new method signatures
  * Added control term
  * Added smoothing capability for delayed measurements
  * Making variables in navsat_transform conform to ROS coding standards
  * Contributors: Adel Fakih, Ivor Wanders, Marc Essinger, Tobias Tueylue, Tom Moore

 -- Tom Moore <ayrton04@gmail.com>  Thu, 28 Jul 2016 07:00:00 -0000

ros-rolling-robot-localization (2.2.3-1focal) focal; urgency=high

  * Cleaning up callback data structure and callbacks and updating doxygen comments in headers
  * Removing MessageFilters
  * Removing deprecated parameters
  * Adding the ability to handle GPS offsets from the vehicle's origin
  * Cleaning up navsat_transform.h
  * Making variables in navsat_transform conform to ROS coding standards

 -- Tom Moore <ayrton04@gmail.com>  Sun, 24 Apr 2016 07:00:00 -0000

ros-rolling-robot-localization (2.2.2-1focal) focal; urgency=high

  * Updating trig functions to use sincos for efficiency
  * Updating licensing information and adding Eigen MPL-only flag
  * Added state to imu frame transformation
  * Using state orientation if imu orientation is missing
  * Manually adding second spin for odometry and IMU data that is passed to message filters
  * Reducing delay between measurement reception and filter output
  * Zero altitute in intital transform too, when zero altitude param is set
  * Fixing regression with conversion back to GPS coordinates
  * Switched cropping of orientation data in inovationSubset with mahalanobis check to prevent excluding measurements with orientations bigger/smaller than ± PI
  * Fix Jacobian for EKF.
  * Removing warning about orientation variables when only their velocities are measured
  * Checking for -1 in IMU covariances and ignoring relevant message data
  * roslint and catkin_lint applied
  * Adding base_link to datum specification, and fixing bug with order of measurement handling when a datum is specified. Also added check to make sure IMU data is transformable before using it.
  * Contributors: Adnan Ademovic, Jit Ray Chowdhury, Philipp Tscholl, Tom Moore, ayrton04, kphil

 -- Tom Moore <ayrton04@gmail.com>  Thu, 04 Feb 2016 08:00:00 -0000

ros-rolling-robot-localization (2.2.1-1focal) focal; urgency=high

  * Fixed handling of IMU data w.r.t. differential mode and relative mode

 -- Tom Moore <ayrton04@gmail.com>  Wed, 27 May 2015 07:00:00 -0000

ros-rolling-robot-localization (2.2.0-1focal) focal; urgency=high

  * Added tf2-friendly tf_prefix appending
  * Corrected for IMU orientation in navsat_transform
  * Fixed issue with out-of-order measurements and pose resets
  * Nodes now assume ENU standard for yaw data
  * Removed gps_common dependency
  * Adding option to navsat_transform_node that enables the use of the heading from the odometry message instead of an IMU.
  * Changed frame_id used in setPoseCallback to be the world_frame
  * Optimized Eigen arithmetic for signficiant performance boost
  * Migrated to tf2
  * Code refactoring and reorganization
  * Removed roll and pitch from navsat_transform calculations


=== debian/control ===
Source: ros-rolling-robot-localization
Section: misc
Priority: optional
Maintainer: Tom Moore <ayrton04@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libboost-dev, libeigen3-dev, libgeographic-dev, ros-rolling-ament-cmake, ros-rolling-ament-cmake-gtest, ros-rolling-ament-lint-auto, ros-rolling-ament-lint-common, ros-rolling-builtin-interfaces, ros-rolling-diagnostic-msgs, ros-rolling-diagnostic-updater, ros-rolling-geographic-msgs, ros-rolling-geometry-msgs, ros-rolling-launch-ros, ros-rolling-launch-testing-ament-cmake, ros-rolling-message-filters, ros-rolling-nav-msgs, ros-rolling-rclcpp, ros-rolling-rmw-implementation, ros-rolling-rosidl-default-generators, ros-rolling-sensor-msgs, ros-rolling-std-msgs, ros-rolling-std-srvs, ros-rolling-tf2, ros-rolling-tf2-eigen, ros-rolling-tf2-geometry-msgs, ros-rolling-tf2-ros, ros-rolling-yaml-cpp-vendor, ros-rolling-ros-workspace, ros-rolling-rosidl-typesupport-fastrtps-c, ros-rolling-rosidl-typesupport-fastrtps-cpp
Homepage: http://ros.org/wiki/robot_localization
Standards-Version: 3.9.2

Package: ros-rolling-robot-localization
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-dev, libeigen3-dev, libgeographic-dev, ros-rolling-diagnostic-msgs, ros-rolling-diagnostic-updater, ros-rolling-geographic-msgs, ros-rolling-geometry-msgs, ros-rolling-message-filters, ros-rolling-nav-msgs, ros-rolling-rclcpp, ros-rolling-rmw-implementation, ros-rolling-rosidl-default-runtime, ros-rolling-sensor-msgs, ros-rolling-std-msgs, ros-rolling-std-srvs, ros-rolling-tf2, ros-rolling-tf2-eigen, ros-rolling-tf2-geometry-msgs, ros-rolling-tf2-ros, ros-rolling-yaml-cpp-vendor, ros-rolling-ros-workspace
Description: Provides nonlinear state estimation through sensor fusion of an abritrary number of sensors.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-robot-localization//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-robot-localization 3.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 project(robot_localization)
 
 if(NOT WIN32)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17")
 endif()
 
 if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
@@ -15,6 +15,7 @@
 endif()
 
 find_package(ament_cmake REQUIRED)
+find_package(angles REQUIRED)
 find_package(rclcpp REQUIRED)
 find_package(diagnostic_msgs REQUIRED)
 find_package(diagnostic_updater REQUIRED)
@@ -35,7 +36,7 @@
 
 # Geographiclib installs FindGeographicLib.cmake to this non-standard location
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "/usr/share/cmake/geographiclib/")
-find_package(GeographicLib REQUIRED COMPONENTS STATIC)
+find_package(GeographicLib REQUIRED)
 
 set(library_name rl_lib)
 
@@ -104,6 +105,7 @@
 
 ament_target_dependencies(
   ${library_name}
+  angles
   diagnostic_msgs
   diagnostic_updater
   geographic_msgs
@@ -196,20 +198,30 @@
   rosidl_get_typesupport_target(cpp_typesupport_target "${PROJECT_NAME}" "rosidl_typesupport_cpp")
   target_link_libraries(test_ekf "${cpp_typesupport_target}")
 
-  ament_add_gtest_executable(test_ekf_localization_node_interfaces
-                    test/test_ekf_localization_node_interfaces.cpp)
-  target_link_libraries(test_ekf_localization_node_interfaces ${library_name})
-
-  rosidl_get_typesupport_target(cpp_typesupport_target "${PROJECT_NAME}" "rosidl_typesupport_cpp")
-  target_link_libraries(test_ekf_localization_node_interfaces "${cpp_typesupport_target}")
-
-  add_dependencies(test_ekf_localization_node_interfaces ekf_node)
-  ament_add_test(test_ekf_localization_node_interfaces
+  ament_add_gtest_executable(
+    test_ekf_node_interfaces
+    test/test_se_node_interfaces.cpp)
+  target_link_libraries(
+    test_ekf_node_interfaces
+    ${library_name})
+
+  rosidl_get_typesupport_target(
+    cpp_typesupport_target
+    "${PROJECT_NAME}" "rosidl_typesupport_cpp")
+  target_link_libraries(
+    test_ekf_node_interfaces
+    "${cpp_typesupport_target}")
+
+  add_dependencies(
+    test_ekf_node_interfaces
+    ekf_node)
+  ament_add_test(
+    test_ekf_node_interfaces
     GENERATE_RESULT_FOR_RETURN_CODE_ZERO
     TIMEOUT 300
-    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/test/test_ekf_localization_node_interfaces.launch.py"
-  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
-  )
+    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/test/test_se_node_interfaces.launch.py"
+    ENV NODE_TYPE=ekf
+  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
 
   #### UKF TESTS #####
   ament_add_gtest(test_ukf test/test_ukf.cpp)
@@ -218,20 +230,30 @@
   rosidl_get_typesupport_target(cpp_typesupport_target "${PROJECT_NAME}" "rosidl_typesupport_cpp")
   target_link_libraries(test_ukf "${cpp_typesupport_target}")
 
-  ament_add_gtest_executable(test_ukf_localization_node_interfaces
-                    test/test_ukf_localization_node_interfaces.cpp)
-  target_link_libraries(test_ukf_localization_node_interfaces ${library_name})
-
-  rosidl_get_typesupport_target(cpp_typesupport_target "${PROJECT_NAME}" "rosidl_typesupport_cpp")
-  target_link_libraries(test_ukf_localization_node_interfaces "${cpp_typesupport_target}")
-
-  add_dependencies(test_ukf_localization_node_interfaces ukf_node)
-  ament_add_test(test_ukf_localization_node_interfaces
+  ament_add_gtest_executable(
+    test_ukf_node_interfaces
+    test/test_se_node_interfaces.cpp)
+  target_link_libraries(
+    test_ukf_node_interfaces
+    ${library_name})
+
+  rosidl_get_typesupport_target(
+    cpp_typesupport_target
+    "${PROJECT_NAME}" "rosidl_typesupport_cpp")
+  target_link_libraries(
+    test_ukf_node_interfaces
+    "${cpp_typesupport_target}")
+
+  add_dependencies(
+    test_ukf_node_interfaces
+    ukf_node)
+  ament_add_test(
+    test_ukf_node_interfaces
     GENERATE_RESULT_FOR_RETURN_CODE_ZERO
     TIMEOUT 300
-    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/test/test_ukf_localization_node_interfaces.launch.py"
-  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
-  )
+    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/test/test_se_node_interfaces.launch.py"
+    ENV NODE_TYPE=ukf
+  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
 
   #### DATA TESTS #####
 #  ament_add_gtest(test_ekf_localization_node_bag1 test/test_localization_node_bag_pose_tester.cpp)
@@ -292,9 +314,9 @@
     filter_base-test
     test_filter_base_diagnostics_timestamps
     test_ekf
-    test_ekf_localization_node_interfaces
+    test_ekf_node_interfaces
     test_ukf
-    test_ukf_localization_node_interfaces
+    test_ukf_node_interfaces
     #test_ekf_localization_node_bag1
     #test_ekf_localization_node_bag2
     #test_ekf_localization_node_bag3
@@ -330,6 +352,11 @@
   RUNTIME DESTINATION bin
 )
 
+install(DIRECTORY
+  include/
+  DESTINATION include/${PROJECT_NAME}
+  USE_SOURCE_PERMISSIONS)
+
 # Install params config files.
 install(DIRECTORY
   params

=== debian/changelog ===
ros-rolling-robot-localization (3.6.0-1jammy) jammy; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Tom Moore <ayrton04@gmail.com>  Wed, 24 May 2023 19:33:53 -0000

ros-rolling-robot-localization (3.3.2-1jammy) jammy; urgency=high

  * Port PR #753 <https://github.com/cra-ros-pkg/robot_localization/issues/753> and #728 <https://github.com/cra-ros-pkg/robot_localization/issues/728> to ROS2 version (#765 <https://github.com/cra-ros-pkg/robot_localization/issues/765>)
    * compiling version of commit #753 <https://github.com/cra-ros-pkg/robot_localization/issues/753> and #728 <https://github.com/cra-ros-pkg/robot_localization/issues/728> ported to ros2 rolling
    * format fixes
    * fix time source disagreement by converting to seconds beforehand, append parameter usage, fix linting
    * fix linting and uncrustify
  * Adding support for setting diagonals for covariance matrices (#755 <https://github.com/cra-ros-pkg/robot_localization/issues/755>)
  * Fixing and cleaning up interface tests (#754 <https://github.com/cra-ros-pkg/robot_localization/issues/754>)
    * Fixing and cleaning up interface tests
  * Linting and header cleanup, part 1 (#752 <https://github.com/cra-ros-pkg/robot_localization/issues/752>)
    * Header cleanup and logging fixes
  * UKF update (#751 <https://github.com/cra-ros-pkg/robot_localization/issues/751>)
    * Pulling UKF changes from Noetic
    * Adding a reset service to make tests more deterministic
  * Fix angles dependency (#747 <https://github.com/cra-ros-pkg/robot_localization/issues/747>)
    * Add angles to CMakeLists.txt
  * Using angles library to normalize angles (#739 <https://github.com/cra-ros-pkg/robot_localization/issues/739>)
    * Using angles library for innovation angle normalization
  * Read predict_to_current_time from ROS parameters (#737 <https://github.com/cra-ros-pkg/robot_localization/issues/737>)
    Co-authored-by: Zygfryd Wieszok <mailto:zwieszok@autonomous-systems.pl>
  * Fixed state history reversion (#736 <https://github.com/cra-ros-pkg/robot_localization/issues/736>)
    Co-authored-by: Zygfryd Wieszok <mailto:zwieszok@autonomous-systems.pl>
  * Fixing code style divergence for ament_uncrustify in main ROS2 branch (#743 <https://github.com/cra-ros-pkg/robot_localization/issues/743>)
  * This fixes #732 <https://github.com/cra-ros-pkg/robot_localization/issues/732> (broadcast_cartesian_transform) (#733 <https://github.com/cra-ros-pkg/robot_localization/issues/733>)
  * Contributors: Anish, Haoguang Yang, Marek Piechula, RoboTech Vision, Tom Moore, Tony Najjar, Zygfryd Wieszok

 -- Tom Moore <ayrton04@gmail.com>  Sun, 11 Dec 2022 08:00:00 -0000

ros-rolling-robot-localization (3.3.1-1jammy) jammy; urgency=high

  * Moving to C++17 support (#725 <https://github.com/cra-ros-pkg/robot_localization/issues/725>)
  * SHARED linking for Geographiclib (#624 <https://github.com/cra-ros-pkg/robot_localization/issues/624>) (#712 <https://github.com/cra-ros-pkg/robot_localization/issues/712>)
    * remove GeographicLib specific linking option
    Co-authored-by: Achmad Fathoni <mailto:fathoni.id@gmail.com>
  * Contributors: Stephan Sundermann, Tom Moore

 -- Tom Moore <ayrton04@gmail.com>  Fri, 25 Feb 2022 08:00:00 -0000

ros-rolling-robot-localization (2.4.0-1jammy) jammy; urgency=high

  * Updated documentation
  * Added reset_on_time_jump option
  * Added feature to optionally publish utm frame as parent in navsat_transform_node
  * Moved global callback queue reset
  * Added initial_state parameter and documentation
  * Fixed ac/deceleration gains default logic
  * Added gravity parameter
  * Added delay and throttle if tf lookup fails
  * Fixed UKF IMUTwistBasicIO test
  * Added transform_timeout parameter
  * Set gps_odom timestamp before tf2 lookuptransform
  * Removed non-portable sincos calls
  * Simplified logic to account for correlated error
  * Added dynamic process noise covariance calculation
  * Fixed catkin_package Eigen warning
  * Added optional publication of acceleration state
  * Contributors: Brian Gerkey, Enrique Fernandez, Jochen Sprickerhof, Rein Appeldoorn, Simon Gene Gottlieb, Tom Moore

 -- Tom Moore <ayrton04@gmail.com>  Mon, 12 Jun 2017 07:00:00 -0000

ros-rolling-robot-localization (2.3.1-1jammy) jammy; urgency=high

  * Adding gitignore
  * Adding remaining wiki pages
  * Adding config and prep pages
  * Adding navsat_transform_node documentation
  * use_odometry_yaw fix for n_t_n
  * Fixing issue with manual pose reset when history is not empty
  * Getting inverse transform when looking up robot's pose.
  * Sphinx documentation
  * Removing forward slashes from navsat_transform input topics for template launch file
  * Adding example launch and parameter files for a two-level EKF setup with navsat_transform_node
  * Adding yaml file for navsat_transform_node, and moving parameter documentation to it.
  * Updating EKF and UKF parameter templates with usage comments
  * Contributors: Tom Moore, asimay

 -- Tom Moore <ayrton04@gmail.com>  Thu, 27 Oct 2016 07:00:00 -0000

ros-rolling-robot-localization (2.3.0-1jammy) jammy; urgency=high

  * Fixed issues with datum usage and frame_ids
  * Fixed comment for wait_for_datum
  * Fixing issue with non-zero navsat sensor orientation offsets
  * Fixing issue with base_link->gps transform wrecking the 'true' UTM position computation
  * Using correct covariance for filtered GPS
  * Fixed unitialized odometry covariance bug
  * Added filter history and measurement queue behavior
  * Changing output timestamp to more accurately use the time stamp of the most recently-processed measurement
  * Added TcpNoDelay()
  * Added parameter to make transform publishing optional
  * Fixed differential handling for pose data so that it doesn't care about the message's frame_id
  * Updated UKF config and launch
  * Added a test case for the timestamp diagnostics
  * Added reporting of bad timestamps via diagnostics


=== debian/control ===
Source: ros-rolling-robot-localization
Section: misc
Priority: optional
Maintainer: Tom Moore <ayrton04@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libboost-dev, libeigen3-dev, libgeographic-dev, ros-rolling-ament-cmake, ros-rolling-ament-cmake-gtest <!nocheck>, ros-rolling-ament-lint-auto <!nocheck>, ros-rolling-ament-lint-common <!nocheck>, ros-rolling-angles, ros-rolling-builtin-interfaces, ros-rolling-builtin-interfaces <!nocheck>, ros-rolling-diagnostic-msgs, ros-rolling-diagnostic-updater, ros-rolling-geographic-msgs, ros-rolling-geometry-msgs, ros-rolling-launch-ros <!nocheck>, ros-rolling-launch-testing-ament-cmake <!nocheck>, ros-rolling-message-filters, ros-rolling-nav-msgs, ros-rolling-rclcpp, ros-rolling-rmw-implementation, ros-rolling-rosidl-default-generators, ros-rolling-sensor-msgs, ros-rolling-std-msgs, ros-rolling-std-srvs, ros-rolling-tf2, ros-rolling-tf2-eigen, ros-rolling-tf2-geometry-msgs, ros-rolling-tf2-ros, ros-rolling-yaml-cpp-vendor, ros-rolling-ros-workspace, ros-rolling-rosidl-typesupport-fastrtps-c, ros-rolling-rosidl-typesupport-fastrtps-cpp
Homepage: http://ros.org/wiki/robot_localization
Standards-Version: 3.9.2

Package: ros-rolling-robot-localization
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-dev, libeigen3-dev, libgeographic-dev, ros-rolling-angles, ros-rolling-diagnostic-msgs, ros-rolling-diagnostic-updater, ros-rolling-geographic-msgs, ros-rolling-geometry-msgs, ros-rolling-message-filters, ros-rolling-nav-msgs, ros-rolling-rclcpp, ros-rolling-rmw-implementation, ros-rolling-rosidl-default-runtime, ros-rolling-sensor-msgs, ros-rolling-std-msgs, ros-rolling-std-srvs, ros-rolling-tf2, ros-rolling-tf2-eigen, ros-rolling-tf2-geometry-msgs, ros-rolling-tf2-ros, ros-rolling-yaml-cpp-vendor, ros-rolling-ros-workspace
Description: Provides nonlinear state estimation through sensor fusion of an abritrary number of sensors.

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
